//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2008 by Eran Ifrah                            
// file name            : macrosdlg.h              
//                                                                          
// -------------------------------------------------------------------------
// A                                                                        
//              _____           _      _     _ _                            
//             /  __ \         | |    | |   (_) |                           
//             | /  \/ ___   __| | ___| |    _| |_ ___                      
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )                     
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/                     
//              \____/\___/ \__,_|\___\_____/_|\__\___|                     
//                                                                          
//                                                  F i l e                 
//                                                                          
//    This program is free software; you can redistribute it and/or modify  
//    it under the terms of the GNU General Public License as published by  
//    the Free Software Foundation; either version 2 of the License, or     
//    (at your option) any later version.                                   
//                                                                          
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifndef __macrosdlg__
#define __macrosdlg__

/**
@file
Subclass of MacrosBaseDlg, which is generated by wxFormBuilder.
*/

#include "macrosbasedlg.h"

/** Implementing MacrosBaseDlg */
class MacrosDlg : public MacrosBaseDlg
{
	long m_item;
	int m_content;
	
public:	
	enum {
		MacrosProject,
		MacrosCompiler
	};
	
protected:
	// Handlers for MacrosBaseDlg events.
	void OnItemRightClick( wxListEvent& event );
	void OnCopy(wxCommandEvent &e);
	void Initialize();
	void AddMacro(const wxString &name, const wxString &desc);
	
	DECLARE_EVENT_TABLE()
	
public:
	/** Constructor */
	MacrosDlg( wxWindow* parent, int content );
	virtual ~MacrosDlg();
};

#endif // __macrosdlg__
