//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2008 by Eran Ifrah
// file name            : svnoptionsdlg.h
//
// -------------------------------------------------------------------------
// A
//              _____           _      _     _ _
//             /  __ \         | |    | |   (_) |
//             | /  \/ ___   __| | ___| |    _| |_ ___
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/
//              \____/\___/ \__,_|\___\_____/_|\__\___|
//
//                                                  F i l e
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
 #ifndef __svnoptionsdlg__
#define __svnoptionsdlg__

/**
@file
Subclass of SvnOptionsBaseDlg, which is generated by wxFormBuilder.
*/

#include "svnoptionsbasedlg.h"
#include "svnoptions.h"

class IManager;

/** Implementing SvnOptionsBaseDlg */
class SvnOptionsDlg : public SvnOptionsBaseDlg
{
	SvnOptions m_options;
	IManager *m_manager;

protected:
	// Handlers for SvnOptionsBaseDlg events.
	void OnButtonOk( wxCommandEvent& event );
	void OnSvnUseIcons(wxCommandEvent &e);
	void SaveOptions();
	void OnEnableExternalDiffViewerUI(wxUpdateUIEvent &e);
	void OnButtonBrowseSSHClient(wxCommandEvent &e);
public:
	/** Constructor */
	SvnOptionsDlg( wxWindow* parent, const SvnOptions& options, IManager *manager );
	virtual ~SvnOptionsDlg();
	const SvnOptions& GetOptions() const{return m_options;}
};

#endif // __svnoptionsdlg__
